#pragma once
#include "pandaAlgorithm.h"
#include "OptScheduling.h"
#include  <vector>

/**
*@brief ֱŻ
*/
class PANDAALGORITHM_API  FirstOptScheduling:public OptScheduling
{
public:
	FirstOptScheduling();
	~FirstOptScheduling();


	/**
	* @brief Ŀ꺯Ӧֵ
	* @param [in] monitorVals
	*/
	virtual double objectiveFunction(float cost, const map<string, double>& monitorVals);
	/**
	* @brief ѹ
	* @param [in] HC[i]: ѹiԤѹֵ
	* @param [in] HF[I]: ѹiҪ͹ˮѹ
	* @return
	*/
	virtual double pressureDifference(const std::vector<double>& HC, const std::vector<double>& HF);

	/**
	* @brief ˮùˮ
	* @param
	* @param
	* @return
	*/
	virtual double pumpPower(const PumpStruct& pumpParam);

	/**
	* @brief ˮɱ
	* @param [vector<double>] Q[i] iվˮ
	* @param [vector<double>] S3[i] iվˮɱλ: Ԫ/m3
	* @return
	*/
	virtual double waterProductionCost(const vector<double>& Q, const vector<double>& S3);

	virtual double waterSupplyAndDemand(const vector<double>& Q, const double& Qd);
};
