#pragma once
#include <string>
#include <vector>
#include <map>

using namespace std;

/**
  Żȿͻ
*/
class CivOptSchedEngine
{
public:
	explicit CivOptSchedEngine(const string& uri);

	bool optimalScheduling();

	// ü
	void setMonitor(const map<string, vector<double>>& monitorMap);

	// þ߱״̬λ
	void setDecisionVariableStatusBit(const map<int, string>& statusMap);

	// õȿʼʱ
	void setStartTime(const string& time);

	// õȽʱ
	void setEndTime(const string& time);

protected:
	/**
	*@brief תΪjsonַ
	*@param [out] json ַ
	*/
	void schedulingResultToJson(string& json);

private:
	// ״̬ӳ
	map<int, string> mStatusBit;

	// ѡ
	map<string, int> mPumpBestStatus;

	// 
	map<string, vector<double>> mMonitoring;
	vector<map<string, double>> mBforeSchedulingResults;
	vector<map<string, double>> mAfterSchedulingResults;

	// ӵַ
	string mUri;

	// ȿʼʱ
	string mStartTime;

	// Ƚʱ
	string mEndTime;

	// ʼȺС
	int popsize;

	// 
	double mMutRate;

	// 
	double mCrossRate;

	//볤
	int mGenLength;

	// Ը
	double mLeftPoint;
	double mRightPoint;
};
