#pragma once
#include<string>
#include<vector>
#include<map>
#include "pandaDbManager.h"

#include "CivConnection.h"


class PANDADBMANAGER_API CivHydrTableHelper
{
public:

	explicit CivHydrTableHelper(const std::string& uri);
	~CivHydrTableHelper();

	bool mainTain();

	void getCodeToSn(const std::string& code, std::string& sn);
private:
	void updateAssem(const std::string& table, const std::string& filed, const std::string& prefix);
	bool topoMaintain();
	bool unTopoMaintain();
	bool unTopoTable(const std::string& table, const std::vector<std::string>& fields);
	/**
	*@brief άͼͼ֮άϵ
	*@param lineTable ͼ
	*@param pointTable ͼ
	*@param linesn ͼֶ
	*@param pointSn ͼֶ
	*@param code ͼʶ
	*/
	bool topoMainTable(const std::string& lineTable,
		const std::string& pointTable,
		const std::string& linesn,
		const std::string& pointSn,
		const std::string& code);
	/**
	 *@brief άţҪ⴦
	 */
	bool topoValve(const std::string& sn,const std::string& fromcode,const std::string& tocode );

	bool topoLikelyPipe(const std::string& pipeTable, const std::string& nodeTable, 
		const std::string& filed, const std::string& tocode);
private:
	std::vector<std::string> mNecessTables;
	std::map<std::string, std::string> mNeedTableMap;
	std::string mErrInfo;

	CivConnection* mConn;
};
