#pragma once
#include "CivInpBuilder.h"

/**
* inpļ
*/
class CivBaseInpBuilder :public CivInpBuilder
{
public:
	explicit CivBaseInpBuilder(const std::string& uri);
	~CivBaseInpBuilder();

	virtual void preHandleLikelyPipe();
	virtual void buildNode();
	virtual void buildPipe();
	virtual void buildTank();
	virtual void buildVavle();
	virtual void buildPump();
	virtual void buildReservoir();
	virtual void buildEmitter();
	virtual void buildPatterns();
	virtual void buildCoordnates();
	virtual void buildVertices();
	virtual void buildLabels();
	virtual void buildTags();
	virtual void buildBackDrop();
	virtual void buildQuality();
	virtual void buildSources();
	virtual void buildMixing();
	virtual void buildCurves();
	virtual void buildStatus();
	virtual void buildControls();
	virtual void buildRules();
	virtual void buildDemands();
};
