#ifndef CIVSIMULRESULTCACHE_H
#define CIVSIMULRESULTCACHE_H

#include <map>
#include <vector>
#include "CivSimuResStruct.h"

using namespace std;

/**
     ģ
*/
class CivSimulResultCache
{
public:
	/**
	*@brief ڵˮ
	*@param quality洢ֵ
	*@param intervalģڼ
	*@param sNo
	*/
	void addNodeQuality(float quality, int interval, const string& sNo);

	/**
	*@brief ˮ
	*@param quality洢ֵ
	*@param intervalģڼ
	*@param sNo߱
	*/
	void addLinkQuality(float quality, int interval, const string& sNo);

	
	void addNodeChlorine(float quality, int interval, const string& sNo);

	void addLinkChlorine(float quality, int interval, const string& sNo);

	/**
	*@brief ڵˮģ
	*@param nodeItemڵˮֵ
	*/
	void addNodeItems(int interval,NodeResultItem& nodeItem);

	/**
	 *@brief ˮģ
	 *@param linkItemģ
	 */
	void addLinkItems(int interval,LinkResultItem& linkItem);

	/**
	*@brief ͷŻĽֵ
	*/
	void clear();

	bool save(const string& uri);

	void getPipesSnsByQuality(std::vector<std::vector<std::string>>&);

	void getAllNodeCoords(const std::string& uri,NodeCoords& nodeCoords);
	void getAllPipeCoords(const std::string& uri,PipeCoords& pipeCoords);
	void getNodeItemByInterval(int time, NodeResultItems& nodeItem);
	void getPipeItemByInterval(int time, LinkResultItems& linkItem);
	void getCodeToSnMap(const string& uri);

private:
	map<int, NodeResultItems> mNodeItemsMap; // ģ
	map<int, LinkResultItems> mLinkItemsMap; // 
	map<int, TankResultItems> mTankItemsMap;

	map<string, string> mNodeCodeSnMap;
	map<string, string> mLineCodeSnMap;
};
#endif // !CIVSIMULRESULTCACHE_H
