#pragma once
#include "CivConnection.h"
#include <vector>
#include <libpq-fe.h>

#define SAFEDELETE(a)  if((a)!=nullptr){delete a;a=nullptr;}

/**
	postgress 
*/
class CivPgDbConnection : public CivConnection
{
public:
	explicit CivPgDbConnection();
	~CivPgDbConnection();

	/**
	*@brief ݣйʵ
	*/
	virtual bool connect(const std::string& url);

	/**
	*@brief رݣйʵ
	*/
	virtual bool disconnect();

	/**
	*@brief ִвѯйʵ
	*@param sql ִsql
	*/
	virtual bool execSql(const std::string& sql);

	virtual bool queryResult(std::vector<std::map<std::string, std::string>>& result);

	virtual bool beginTransaction();
	virtual bool commitTransaction();

private:
	PGconn* mConn; // Ӷ
	PGresult* mResult;  // ѯ
};
